KFonas::KFonas(): pas(0.0)
{
}


KFonas::~KFonas()
{
}


void KFonas::Sukurti()
{
	zv = glGenLists(2);
	
	glNewList(zv + solid, GL_COMPILE);
	glBegin(GL_TRIANGLE_FAN);
		glVertex2f(0.0, 0.0);
		Zvaigzde(5);
	glEnd();
	glEndList();
	
	glNewList(zv + wire, GL_COMPILE);
	glBegin(GL_LINE_STRIP);
		Zvaigzde(5);
	glEnd();
	glEndList();
	
	for(int i = 0; i < KIEK; i++)
		ZvaigzdeAtstatyti(i);
	for(int i = 0; i < PAR_KIEK; i++){
		parNum[i] = 0;
		parDuom[i] = -0.1;
	}
}


void KFonas::Zvaigzde(int kamp)
{
	bool	did = true;
	kamp *= 2;
	for(int i = 0; i <= kamp; i++){
		if(did)
			glVertex2f(sin(M_PI * i / kamp * 2), cos(M_PI * i / kamp * 2));
		else
			glVertex2f(sin(M_PI * i / kamp * 2) / 2.0, cos(M_PI * i / kamp * 2) / 2.0);
		did = !did;
	}
}


void KFonas::ZvaigzdeAtstatyti(int num)
{
	param[num][0] = rand() % langasX;					//X
	param[num][1] = rand() % langasY + langasY + 100.0;	//Y
	param[num][2] = rand() % 1024 / 15.0 + 30.0;		//Krit. gr
	param[num][3] = rand() % 1024 / 30.0 + 10.0;		//Dydis
	param[num][4] = (rand() % 2) * 2.0 - 1.0;			//Pasukimas
}


void KFonas::Atnaujinti()
{
	for(i = 0; i < KIEK; i++){
		//Atstatyti
		if(param[i][1] < -100.0){
			ZvaigzdeAtstatyti(i);
		}
		//Atnaujinti
		param[i][1] -= param[i][2] * laik;
		if(param[i][4] > 0.0)
			param[i][4] += param[i][2] * laik;
		else
			param[i][4] -= param[i][2] * laik;
	}
	pas += laik * 10.0;
	
	//Paryskinimai
	for(i = 0; i < PAR_KIEK; i++)
		if(parDuom[i] >= 0.0)
			parDuom[i] -= laik;
	if(pask4 || pask5)
		Paryskinti();
}


void KFonas::Paryskinti()
{
	//Surandamas anksciausias paryskinimas
	int pask = -1;
	for(i = 0; i < PAR_KIEK; i++)
		if(parDuom[i] <= 0.0)
			pask = i;
	if(pask < 0)
		return;
	//Paryskinama
	do{
		i = rand() % KIEK;
		f = param[i][1];
	}
	while(f > langasY || f < 100);
	parNum[pask] = i;
	parDuom[pask] = 2.0;
}


void KFonas::Piesti()
{
	//Krentancios zvaigzdes
	glColor4f(0.4, 0.4, 0.4, 1.0);
	for(i = 0; i < KIEK; i++){
		glPushMatrix();
		glTranslatef(param[i][0], param[i][1], 0.0);
		glRotatef(param[i][4], 0.0, 0.0, 1.0);
		glScalef(param[i][3] * 2.0, param[i][3] * 2.0, 1.0);
		glCallList(zv + solid);
		glPopMatrix();
	}
	glColor4f(0.0, 0.05, 0.05, 1.0);
	for(i = 0; i < KIEK; i++){
		glPushMatrix();
		glTranslatef(param[i][0], param[i][1], 0.0);
		glRotatef(param[i][4], 0.0, 0.0, 1.0);
		glScalef(param[i][3] * 1.7, param[i][3] * 1.7, 1.0);
		glCallList(zv + solid);
		glPopMatrix();
	}
	
	//Paryskinimai
	for(i = 0; i < PAR_KIEK; i++){
		j = parNum[i];
		f = parDuom[i] * 0.5;
		if(f > 0.0){
			glPushMatrix();
			glTranslatef(param[j][0], param[j][1], 0.0);
			glRotatef(param[j][4], 0.0, 0.0, 1.0);
			glScalef(param[j][3] * 1.7, param[j][3] * 1.7, 1.0);
			glScalef(1.0 + f, 1.0 + f, 1.0 + f);
			glColor4f(0.7 * f, 1.0 * f, 1.0 * f, 1.0);
			glCallList(zv + solid);
			glPopMatrix();
		}
	}
	
	//Statines zvaigzdes
	/*glTranslatef(langasX / 8.0, langasY / 6.0, 0.0);
	for(int i = 0; i < 4; i++){
		for(int j = 0; j < 3; j++){
			glPushMatrix();
			glRotatef(((i + j) % 2 ? pas : -pas) + (i % 2 ? 0 : 36), 0.0, 0.0, 1.0);
			glScalef(170.0, 170.0, 1.0);
			glColor4f(0.0, 0.0, 0.0, 1.0);
			glCallList(zv + solid);
			for(int k = 0; k < 4; k++){
				f = 0.2 - 0.06 * k;
				glColor4f(f, f, f, 1.0);
				glCallList(zv + wire);
				glScalef(0.5, 0.5, 1.0);
				glRotatef((i % 2) ? 36.0 : -36.0, 0.0, 0.0, 1.0);
			}
			glPopMatrix();
			glTranslatef(0.0, langasY / 3.0, 0.0);
		}
		glTranslatef(langasX / 4.0, -langasY, 0.0);
	}*/
}
