KFonasKubai::KFonasKubai(): tek(0), stop(false)
{
}


KFonasKubai::~KFonasKubai()
{
}


void KFonasKubai::Sukurti()
{
	//Nustatomos pradines reiksmes
	for(int i = 0; i < KIEKIS; i++)
		duom[i][0] = 100.0;
	
	//Sukuriama tekstura
	int sk;
	memset(tekDuom, 255, tekDydis);
	for(int i = 0; i < tekDydisi; i++){
		sk = (int)(((i % tekX) & ((int)(i / tekX))) * 63.999) * 128;
		if(sk <= 128)
			sk = 200;
		else
			sk = 0;
		tekDuom[i * 4 + 0] = sk;// / 256 / 256;
		tekDuom[i * 4 + 1] = sk;// / 256;
		tekDuom[i * 4 + 2] = sk;
		//tekDuom[i * 4 + 3] = 100;
	}
	
	//Nukopijuoti i kita puse
	for(int i = 0; i < tekDydisi; i++){
		if(i % tekX + (int)(i / tekX) > tekX){
			tekDuom[i * 4 + 0] = tekDuom[(tekDydisi - i) * 4];
			tekDuom[i * 4 + 1] = tekDuom[(tekDydisi - i) * 4];
			tekDuom[i * 4 + 2] = tekDuom[(tekDydisi - i) * 4];
		}
	}
	
	tek = tekstura.Sukurti();
}


void KFonasKubai::Atnaujinti()
{
	int atstatyta = 0;
	for(int i = 0; i < KIEKIS; i++){
		duom[i][0] += laik;
		if(atstatyta == 0 && duom[i][0] > 20.0 && !stop){
			atstatyta = 1;
			duom[i][0] = -0.05 * (rand() % 1024) - 5.0;
			duom[i][1] = 0.004 * (rand() % 1024) - 2.0;
		}
	}
}


void KFonasKubai::Piesti()
{
	glColor4fv(balta);
	glBindTexture(GL_TEXTURE_2D, tek);
	for(int i = 0; i < 4; i++){
		glPushMatrix();
		glRotatef(90.0, 1.0, 0.0, 0.0);
		glRotatef(i * 90.0, 0.0, 1.0, 0.0);
		glTranslatef(0.0, 0.0, -2.0);
		for(int j = 0; j < KIEKIS_DALIS; j++){
			glPushMatrix();
			glTranslatef(duom[i * KIEKIS_DALIS + j][1], -duom[i * KIEKIS_DALIS + j][0], 0.0);
			geom.Plokst(1.7, 3.0);
			glPopMatrix();
		}
		glPopMatrix();
	}
}
