KKubasWire::KKubasWire(): pas_x(0.0), pas_y(0.0), pas_z(0.0), alpha(0.0)
{
}


KKubasWire::~KKubasWire()
{
}


void KKubasWire::Sukurti()
{
	dydis = 10.0;
	
	//Sukurti tekstura
	memset(tekDuom, 255, tekDydis);
	for(i = 0; i < tekX; i++){
		for(j = 0; j < tekX; j++){
			f = sqrt((i - tekX / 2.0) * (i - tekX / 2.0) + (j - tekX / 2.0) * (j - tekX / 2.0));
			if(f < tekX / 2.0)
				tekDuom[i * tekX * 4 + j * 4 + 3] = (unsigned char)(255.0 - f * 2.0);
			else
				tekDuom[i * tekX * 4 + j * 4 + 3] = 0;
			//(int)(1.0 - sqrt(((float(i) - f) / f) * ((float(i) - f) / f) + ((float(j) - f) / f) * ((float(j) - f) / f)) * 255);
			//(unsigned char)sqrt(((i - f) / f) * ((i - f) / f) + ((j - f) / f) * ((j - f) / f)) * 255; 	//4 ziedai
			//((i % tekX - tekX / 2) * (i % tekX - tekX / 2) + ((i / tekX - tekX / 2) * (i / tekX - tekX / 2)));
		}
	}
	tek = tekstura.Sukurti();
	
	//Sukurti display lista
	dl = glGenLists(1);
	glNewList(dl, GL_COMPILE);
	//Apacia
		//Centro pozicijos keitimas
		glTranslatef(-dydis / 2.0, -dydis / 2.0, -dydis / 2.0);
		PiestiDali();
		glRotatef(90.0, 0.0, 1.0, 0.0);
		PiestiDali();
		
		glTranslatef(0.0, dydis, 0.0);
		glRotatef(90.0, 1.0, 0.0, 0.0);
		PiestiDali();
		glRotatef(-90.0, 0.0, 1.0, 0.0);
		PiestiDali();
		
		glTranslatef(0.0, dydis, 0.0);
		glRotatef(-90.0, 0.0, 0.0, 1.0);
		PiestiDali();
		glRotatef(90.0, 0.0, 1.0, 0.0);
		PiestiDali();
		
		glTranslatef(0.0, dydis, 0.0);
		glRotatef(90.0, 1.0, 0.0, 0.0);
		PiestiDali();
		glRotatef(-90.0, 0.0, 1.0, 0.0);
		PiestiDali();
	//Virsus
		glTranslatef(0.0, 0.0, dydis);
		PiestiDali();
		glRotatef(90.0, 0.0, 1.0, 0.0);
		PiestiDali();
		
		glTranslatef(0.0, dydis, 0.0);
		glRotatef(90.0, 1.0, 0.0, 0.0);
		PiestiDali();
		glRotatef(-90.0, 0.0, 1.0, 0.0);
		PiestiDali();
		
		glTranslatef(0.0, dydis, 0.0);
		glRotatef(-90.0, 0.0, 0.0, 1.0);
		PiestiDali();
		glRotatef(90.0, 0.0, 1.0, 0.0);
		PiestiDali();
		
		glTranslatef(0.0, dydis, 0.0);
		glRotatef(90.0, 1.0, 0.0, 0.0);
		PiestiDali();
		glRotatef(-90.0, 0.0, 1.0, 0.0);
		PiestiDali();
	//Sonai
		glRotatef(-90.0, 1.0, 0.0, 0.0);
		PiestiDali();
		glRotatef(-90.0, 0.0, 1.0, 0.0);
		PiestiDali();
		
		glTranslatef(dydis, 0.0, 0.0);
		PiestiDali();
		glRotatef(90.0, 0.0, 1.0, 0.0);
		PiestiDali();
		
		glTranslatef(dydis, 0.0, 0.0);
		PiestiDali();
		glRotatef(90.0, 0.0, 1.0, 0.0);
		PiestiDali();
		
		glTranslatef(dydis, 0.0, 0.0);
		PiestiDali();
		glRotatef(90.0, 0.0, 1.0, 0.0);
		PiestiDali();
	glEndList();
}


void KKubasWire::PiestiDali()
{
	glBegin(GL_QUAD_STRIP);
	glNormal3f(0.0, 0.0, 1.0);
		glTexCoord2f(0.0, 0.0);
		glVertex3f(-0.5, -0.5, 0.0);
		glTexCoord2f(1.0, 0.0);
		glVertex3f(0.5, -0.5, 0.0);
		
		glTexCoord2f(0.0, 0.5);
		glVertex3f(-0.5, 0.0, 0.0);
		glTexCoord2f(1.0, 0.5);
		glVertex3f(0.5, 0.0, 0.0);
		
		glTexCoord2f(0.0, 0.5);
		glVertex3f(-0.5, dydis, 0.0);
		glTexCoord2f(1.0, 0.5);
		glVertex3f(0.5, dydis, 0.0);
		
		glTexCoord2f(0.0, 1.0);
		glVertex3f(-0.5, dydis + 0.5, 0.0);
		glTexCoord2f(1.0, 1.0);
		glVertex3f(0.5, dydis + 0.5, 0.0);
	glEnd();
}


void KKubasWire::Atnaujinti()
{
	alpha += laik * 0.2;
	if(alpha > 1.0)
		alpha = 1.0;
	pas_x += laik * 19.1;
	pas_y += laik * 27.77;
	pas_z += laik * 15.33;
}


void KKubasWire::Piesti()
{
	glDepthMask(GL_FALSE);
	glPushMatrix();
	glRotatef(pas_x, 1.0, 0.0, 0.0);
	glRotatef(pas_y, 0.0, 1.0, 0.0);
	glRotatef(pas_z, 0.0, 0.0, 1.0);
	glScalef(0.2, 0.2, 0.2);
	glBindTexture(GL_TEXTURE_2D, tek);
	glCallList(dl);
	glPopMatrix();
	glDepthMask(GL_TRUE);
}
