KZiedas::KZiedas()
{
}


KZiedas::~KZiedas()
{
}


void KZiedas::Sukurti(int _kok = 32)
{
	kok = _kok;
	
	//Sukurti tekstura
	memset(tekDuom, 0, tekDydis);
	for(i = 0; i < tekDydisi; i++){
		tekDuom[i * 4 + 0] = ((i % 255) ^ (i / 255) % 255) % 56 + 200;
		tekDuom[i * 4 + 1] = tekDuom[i * 4 + 0];
		tekDuom[i * 4 + 2] = tekDuom[i * 4 + 0];
		tekDuom[i * 4 + 3] = 255;
	}
	tek = tekstura.Sukurti();
	
	//Sukurti display lista
	dl = glGenLists(1);
	glNewList(dl, GL_COMPILE);
	//Virsus
	glBegin(GL_QUAD_STRIP);
	for(i = 0; i <= kok; i++){
		f = M_PI * 2.0 / kok * i;
		glNormal3f(0.0, 0.0, 1.0);
		glTexCoord2f(i * 10.0 / kok, 0.33);
		glVertex3f(cos(f) * 3.5, sin(f) * 3.5, 0.5);
		glNormal3f(0.0, 0.0, 1.0);
		glTexCoord2f(i * 10.0 / kok, 0.66);
		glVertex3f(cos(f) * 4.5, sin(f) * 4.5, 0.5);
	}
	glEnd();
	//Vidus
	glBegin(GL_QUAD_STRIP);
	for(i = 0; i <= kok; i++){
		f = M_PI * 2.0 / kok * i;
		glNormal3f(-cos(f) * 0.707, -sin(f) * 0.707, 0.707);
		glTexCoord2f(i * 10.0 / kok, 0.1);
		glVertex3f(cos(f) * 3.0, sin(f) * 3.0, 0.0);
		glNormal3f(-cos(f) * 0.707, -sin(f) * 0.707, 0.707);
		glTexCoord2f(i * 10.0 / kok, 0.33);
		glVertex3f(cos(f) * 3.5, sin(f) * 3.5, 0.5);
	}
	glEnd();
	//Isore
	glBegin(GL_QUAD_STRIP);
	for(i = 0; i <= kok; i++){
		f = M_PI * 2.0 / kok * i;
		glNormal3f(cos(f) * 0.707, sin(f) * 0.707, 0.707);
		glTexCoord2f(i * 10.0 / kok, 0.66);
		glVertex3f(cos(f) * 4.5, sin(f) * 4.5, 0.5);
		glNormal3f(cos(f) * 0.707, sin(f) * 0.707, 0.707);
		glTexCoord2f(i * 10.0 / kok, 0.99);
		glVertex3f(cos(f) * 5.0, sin(f) * 5.0, 0.0);
	}
	glEnd();
	glEndList();
}


void KZiedas::Piesti()
{
	glPushMatrix();
	glBindTexture(GL_TEXTURE_2D, tek);
	glScalef(0.2, 0.2, 0.2);
	glCallList(dl);
	glPopMatrix();
}
