#ifndef TASKAS_HPP
#define TASKAS_HPP


class KTaskas{
	public:
    float	x,
			y,
			z;
	
	void operator = (const KTaskas);
	void operator = (const KTaskas*);
	void operator += (const KTaskas);
	void operator += (const KTaskas*);
	KTaskas * operator *= (float);
	inline KTaskas operator - (const KTaskas);
	inline KTaskas operator - (const KTaskas*);
	float operator ^ (KTaskas);			//Kampo tarp vektoriu kosinusas
	float operator ^ (KTaskas*);
	
	KTaskas();
	KTaskas(float, float, float);
	~KTaskas();
	
	inline const float Ilgis();			//Grazinamas vektoriaus ilgis
	KTaskas * Ilgis(float ilg);			//Vekstoriaus ilgis nustatomas i ilg
	KTaskas * IlgisMaks(float maks);	//Vektoriaus ilgis ribojamas iki maks
	void Normale(float, float);			//Vektorius (normale) skaiciuojamas pagal plokstumos pasisukimo kampus
};


#include "taskas.cpp"
#endif
