bool Uzkrauti()
{
	//Cia turetu buti nuskaitytas monitoriaus vaizdas, buves pries pajungiant demke, deja veikia tik su nedaugeliu vaizdo ploksciu
	glReadBuffer(GL_FRONT);
	glAccum(GL_LOAD, 1.0);
	screen = new unsigned char[langasX * langasY * 4];
	glReadPixels(0, 0, langasX, langasY, GL_RGBA, GL_UNSIGNED_BYTE, screen);
	
	OglExt::Init();
	#ifdef DEBUG
	if(!OglExt::ok_Multitexture)
		Klaida("Nepalaikomas MultiTexture");
	if(!OglExt::ok_Cubemap)
		Klaida("Nepalaikomas CubeMap");
	#endif
	glGetFloatv(GL_MAX_TEXTURE_MAX_ANISOTROPY_EXT, &anisoMax);
	
	//Garsas
	#ifdef WAV
	WavGen();
	wavFormatas.wFormatTag = WAVE_FORMAT_PCM;
	wavFormatas.nChannels = 1;
	wavFormatas.nSamplesPerSec = 48000;
	wavFormatas.nAvgBytesPerSec = 48000;
	wavFormatas.nBlockAlign = 1;
	wavFormatas.wBitsPerSample = 8;
	wavFormatas.cbSize = 0;
	mmRez = waveOutOpen(&wavOut, WAVE_MAPPER, &wavFormatas, (DWORD)hWnd, 0, CALLBACK_WINDOW);
	if(mmRez != MMSYSERR_NOERROR)
		return false;
	wavHeader.lpData = (CHAR*)wavDuom;
	wavHeader.dwBufferLength = WAV_DYDIS;
	wavHeader.dwBytesRecorded = 0;
	wavHeader.dwUser = 0;
	wavHeader.dwFlags = WHDR_BEGINLOOP | WHDR_ENDLOOP;
	wavHeader.dwLoops = 1;
	#endif
	
	//Tekstas
	if(!tekstas.Sukurti()){
		MessageBox(NULL, "Klaida sukuriant teksta", "KLAIDA", MB_OK|MB_ICONEXCLAMATION);
		return false;
	}
	if(!tekstas2.Sukurti(FW_NORMAL)){
		MessageBox(NULL, "Klaida sukuriant teksta", "KLAIDA", MB_OK|MB_ICONEXCLAMATION);
		return false;
	}
	
	//Teksturos
	
	//Objektai
	geom.Init();
	objektyvas.Sukurti();
	ziedas.Sukurti();
	ziedas2.Sukurti();
	kubasWire.Sukurti();
	kubasTekstas.Sukurti();
	fonas.Sukurti();
	fonasKubai.Sukurti();
	tekstasDemke.Sukurti();
	
	laikas.Pradeti();
	
	return true;
}


void Naikinti()
{
	delete[] screen;
	tekstas.Naikinti();
	geom.Naikinti();
}


#ifdef WAV
void WavGen()
{
	bool did = true;
	float reiksme;
	float faze = 0.0;
	float plius = 0.0;
	int		laiki = 0;
	float	laikf;
	for(int i = 0; i < WAV_DYDIS; i++){
		if(++laiki >= 24000)
			laiki = 0;
		laikf = (float)laiki / 24000.0;
		
		reiksme = sin(plius * M_PI) + cos(plius * M_PI);
		
		//if(laikf > 0.4)
		//	reiksme = 0.0;
		if(reiksme > 1.0)
			reiksme = 1.0;
		wavDuom[i] = 128 + (int)(reiksme) * 128;
		
		if(did)	plius += 0.01;
		else	plius -= 0.01;
		if(plius < 0.0){
			did = true;
			plius = 0.0;
		}
		if(plius > 1.0){
			did = false;
			plius = 1.0;
		}
	}
}
#endif


void Valdymas()
{
	if(spaud[VK_ESCAPE])
		langasBaigti = true;
	
    if(spaud[VK_LEFT])
        kamera.kh += 0.03f;
    if(spaud[VK_RIGHT])
        kamera.kh -= 0.03f;
    if(spaud[VK_UP])
        kamera.kv += 0.03f;
    if(spaud[VK_DOWN])
        kamera.kv -= 0.03f;
        
    /*if(spaud['A']){
        kamera.k.x += -sin(kamera.kh) * greitis;
        kamera[1] += cos(kamera.kh) * greitis;
	}
	if(spaud['D']){
        kamera[0] -= -sin(kampH) * greitis;
        kamera[1] -= cos(kampH) * greitis;
	}
	if(spaud['W']){
        kamera[0] += cos(kampH) * sin(kampV) * greitis;
        kamera[1] += sin(kampH) * sin(kampV) * greitis;
        kamera[2] += -cos(kampV) * greitis;
	}
	if(spaud['S']){
        kamera[0] -= cos(kampH) * sin(kampV) * greitis;
        kamera[1] -= sin(kampH) * sin(kampV) * greitis;
        kamera[2] -= -cos(kampV) * greitis;
	}*/
	
	/*if(spaud['1'])
        dd *= 1.01;
    if(spaud['2'])
        dd *= 0.99;*/
}


void Paspaudimai(int spau)
{
	#ifdef DEBUG
	switch(spau){
		case 'Q':
			laikas.gr *= 4.0;
			break;
		case 'Z':
			laikas.gr *= 0.25;
			break;
	}
	#endif
}


void Atnaujinti()
{
	mGetData(&midiPask, 4, 100);
	if(midiPask.note != paskNata4){
		paskNata4 = midiPask.note;
		pask4 = true;
	}
	else
		pask4 = false;
	mGetData(&midiPask, 5, 100);
	if(midiPask.note != paskNata5){
		paskNata5 = midiPask.note;
		pask5 = true;
	}
	else
		pask5 = false;
	
	/*
	if(faze == 0){
		/*faze = 3;
		faze2 = 2;
		ziedas2.dydis = ziedas2.dydisMin;
		ziedas2.kv = 359.0;
		ziedas2.Baigti();*/
		/*objektyvas.kamp = 0.0;
		kamera.NustKam(0.0, -0.1, 10.0);
		faze = 2;
		faze2 = 3;
	}
	//*/
	switch(faze){
		case 0:
			//Vaizdo uzdengimas
			objektyvas.Atnaujinti();
			if(laikas.faze > 6.0 && faze2 == 0){
				//Kameros atsitraukimas
				laikas.faze = 0.0;
				++faze;
				faze2 = 0;
				kamera.grInert = 2.0;
				kamera.gr2 = 5.0;
				kamera.EitiKam(0.0, -2.0, 3.0);
			}
			break;
		case 1:
			//if(faze2 == 1)
			objektyvasPas -= 10.0 * laik * laikas.faze;
			if(laikas.faze > 5 && faze2 == 0){
				//Objektyvo isvaziavimas
				++faze2;
				kamera.grInert = 1.0;
				kamera.gr2 = 3.0;
				kamera.gr = 0.0;
				kamera.EitiKam(0.0, -0.1, 4.0);
			}

			if(laikas.faze > 12.0 && faze2 == 1){
				//Kameros atsitraukimas
				++faze;
				faze2 = 0;
			}
			break;
		case 2:
			//Kubas
			kubasWire.Atnaujinti();
			if(faze2 < 2)
				kubasTekstas.Atnaujinti();
			if(faze2 == 3)
				ziedas2.Atnaujinti();
			
			if(faze2 == 0){
				//Piesiamas kubas ir tekstas
				++faze2;
				kamera.grInert = 1.0;
				kamera.gr2 = 3.0;
				kamera.gr = 0.0;
				kamera.EitiKam(0.0, -9.0, 2.0);
				kamera.EitiTaik(0.0, 0.0, 0.0);
			}
			if(faze2 == 1 && kubasTekstas.faze > 6500.0){
				//Tekstas isjungiamas, kameros nustatymas is virsaus
				++faze2;
				kamera.EitiKam(0.0, -0.1, 10.0);
			}
			if(faze2 == 2 && kamera.atejo){
				//Ziedo atsiradimas, vaizdo uzdengimas
				++faze2;
			}
			if(faze2 == 3 && ziedas2.kv > 90.0){
				//Fazes perjungimas
				faze2 = 0;
				++faze;
				laikas.faze = 0.0;
			}
			break;
		case 3:
			//Ziedas
			ziedas2.Atnaujinti();
			if(faze2 == 2)
				tekstasDemke.Atnaujinti();
			if(faze2 == 0 && laikas.faze > 5.0){
				//Ziedo sustabdymas
				++faze2;
				ziedas2.Baigti();
			}
			if(faze2 == 1 && ziedas2.baigta){
				//Ziedo atsitraukimas, teksto piesimas
				++faze2;
			}
			if(faze2 == 2 && ziedas2.dydis > 6.5){
				//Fazes perjungimas
				faze2 = 0;
				++faze;
				laikas.faze = 0.0;
			}
			break;
		case 4:
			//Tekstas
			if(faze2 <= 1)
				tekstasDemke.Atnaujinti();
			if(faze >= 1)
				objektyvas.Atnaujinti();
			if(faze2 == 2){
				objektyvasDyd -= laik * 5.0;
				if(objektyvasDyd < 1.0)
					objektyvasDyd = 1.0;
			}
			
			if(tekstasDemke.faze == 1 && faze2 == 0){
				//Uzdarymas
				++faze2;
				objektyvas.kamp = 50.0;
				objektyvas.gr = 10.0;
				objektyvas.dyd = 1.0;
				objektyvasDyd = 15.0;
				objektyvasPas = 0.0;
			}
			if(objektyvas.kamp < 0.1 && faze2 == 1){
				//Atsitraukiama nuo objektyvo
				++faze2;
				kamera.grInert = 1.0;
				kamera.gr2 = 2.0;
				kamera.EitiKam(0.0, -2.0, 3.0);
			}
			if(objektyvasDyd < 1.01 && kamera.atejo && faze2 == 2){
				//Prieiti prie objektyvo
				++faze2;
				kamera.gr = 0.0;
				kamera.EitiKam(0.0, -0.001, 0.66);
			}
			if(faze2 == 3 && kamera.atejo){
				//Perjungti pabaiga
				faze = -1;
				faze2 = 0;
				laikas.faze = 0.0;
				objektyvas.gr = -10.0;
			}
			break;
		case -1:
			//Vaizdo atidengimas
			objektyvas.Atnaujinti();
			if(laikas.faze > 7.0)
				langasBaigti = true;
			break;
	}
	fonasKubai.Atnaujinti();
	fonas.Atnaujinti();
	kamera.Atnaujinti();
}


void Piesti()
{
	/*
	if(laboras == 1)
		Wireframe
	if(laboras > 1)
		Solid
	if(laboras > 2)
		Apsvietimas
		Materialai
	if(laboras > 3)
		Teksturos
	if(laboras > 4)
		Rukas
		Opacity
	if(laboras > 5)
		Animacija
	if(laboras == 7)
		Megaturbo grafika
	*/
	
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT);
	glDisable(GL_DEPTH_TEST);
	if(faze < 1)
		glAccum(GL_RETURN, 1.0);
	
	if(faze > 0){
		
		//Ortografine projekcija
		glMatrixMode(GL_PROJECTION);
		glLoadIdentity();
		glOrtho(0, langasX, 0, langasY, 1.0, -1.0);
		glMatrixMode(GL_MODELVIEW);
		glLoadIdentity();
		
		fonas.Piesti();
		
		//Perspektyvine projekcija
		glMatrixMode(GL_PROJECTION);
		glLoadIdentity();
		gluPerspective(45.0f, (float)langasX / (float)langasY, 0.1f, 50.0f);		//fovy, aspect, near, far
		glMatrixMode(GL_MODELVIEW);
		glLoadIdentity();    
		gluLookAt(0.0, 0.0, 2.0,	//Kamera
			0.01, 0.0, 0.0,			//Taikinys
			0.0, 0.0, 1.0);			//Up
		
		glEnable(GL_FOG);
		glEnable(GL_TEXTURE_2D);
		fonasKubai.Piesti();
		glDisable(GL_TEXTURE_2D);
		glDisable(GL_FOG);
	}
	
	//Perspektyvine projekcija
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(45.0f, (float)langasX / (float)langasY, 0.1f, 100.0f);		//fovy, aspect, near, far
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();    
	gluLookAt(kamera.k.x, kamera.k.y, kamera.k.z,	//Kamera
		kamera.t.x, kamera.t.y, kamera.t.z,			//Taikinys
		0.0, 0.0, 1.0);			//Up
	glEnable(GL_DEPTH_TEST);
	glColor4fv(balta);
	
	glEnable(GL_LIGHTING);
	glEnable(GL_LIGHT0);
	glLightfv(GL_LIGHT0, GL_POSITION, apsvPoz);
	glEnable(GL_TEXTURE_2D);
	
	
	if(faze <= 1){
		glPushMatrix();
		glTranslatef(-objektyvasPas / 80.0, 0.0, 0.0);
		glRotatef(objektyvasPas, 0.0, 0.0, 1.0);
		objektyvas.Piesti();
		ziedas.Piesti();
		glPopMatrix();
	}
	
	
	if(faze == 2 && faze2 == 3){
		//Rasoma i stencil buferi
		glEnable(GL_STENCIL_TEST);
		glStencilFunc(GL_ALWAYS, 1, 1);
		glStencilOp(GL_KEEP, GL_KEEP, GL_REPLACE);
		glDepthMask(GL_FALSE);
		glColorMask(GL_FALSE, GL_FALSE, GL_FALSE, GL_FALSE);
		ziedas2.PiestiStencil();
		glDepthMask(GL_TRUE);
		glColorMask(GL_TRUE, GL_TRUE, GL_TRUE, GL_TRUE);
		//Pasiruosiama piesimui
		glStencilFunc(GL_EQUAL, 1, 1);
		glStencilOp(GL_KEEP, GL_KEEP, GL_KEEP);
	}
	if(faze == 2){
		glDisable(GL_LIGHT0);
		glDisable(GL_LIGHTING);
		glDisable(GL_DEPTH_TEST);
		kubasWire.Piesti();
		glPushMatrix();
		for(i = 0; i < 7; i++){
			glScalef(1.15, 1.15, 1.15);
			glColor4f(1.0, 1.0, 1.0, (0.32 - 0.05 * i) * kubasWire.alpha);
			kubasWire.Piesti();
		}
		glPopMatrix();
		glColor4f(1.0, 1.0, 1.0, kubasWire.alpha);
		glPushMatrix();
		glRotatef(90.0, 0.707, 0.707, 0.0);
		glScalef(0.4, 0.4, 0.4);
		kubasWire.Piesti();
		glPopMatrix();
		
		if(faze2 < 2)
			kubasTekstas.Piesti();
		else{
			glEnable(GL_LIGHTING);
			glEnable(GL_LIGHT0);
		}
		glEnable(GL_DEPTH_TEST);
	}
	if(faze == 2 && faze2 == 3){
		//Isjungiamas stencil
		glDisable(GL_STENCIL_TEST);
		ziedas2.Piesti();
	}
	
	
	if(faze == 3){
		//glEnable(GL_FOG);
		ziedas2.Piesti();
		//glDisable(GL_FOG);
	}
	
	
	if((faze == 4 && faze2 <= 1) || (faze == 3 && faze2 == 2)){
		glDisable(GL_DEPTH_TEST);
		glDisable(GL_LIGHTING);
		tekstasDemke.Piesti();
		glEnable(GL_LIGHTING);
		glEnable(GL_DEPTH_TEST);
	}
	if(faze == 4 && faze2 > 0){
		glColor4fv(balta);
		glPushMatrix();
		glScalef(objektyvasDyd, objektyvasDyd, 1.0);
		objektyvas.Piesti();
		ziedas.Piesti();
		glPopMatrix();
	}
	
	
	glDisable(GL_LIGHT0);
	glDisable(GL_LIGHTING);
	
	
	#ifdef DEBUG
	//Ortografine projekcija
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glOrtho(0, langasX, 0, langasY, 1.0, -1.0);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	glColor4fv(balta);
	
	glTranslatef(10.0, langasY - 20.0, 0.0);
	glScalef(0.4, 0.4, 1.0);
	tekstas.PiestiNeform("FPS: %i   %.2f  %.2f", laikas.FPS, tekstasDemke.dydis, tekstasDemke.dydis / tekstas.dydis2);
	glLoadIdentity();
	glTranslatef(105.0, 105.0, 0.0);
	glScalef(200.0, 200.0, 1.0);
	glBindTexture(GL_TEXTURE_2D, ziedas2.tek);
	geom.Plokst();
	#endif
	glDisable(GL_TEXTURE_2D);
}
