#ifndef FONAS_HPP
#define FONAS_HPP


class KFonas
{
	static const int KIEK = 32;
	float	param[KIEK][5];		//x, y, krit. gr., dydis, pasukimas
	static const int solid = 0;
	static const int wire = 1;
	float	pas;	//Didziuju zvaigzdziu pasukimas
	GLuint	zv;
	//Paryskinimai
	static const int PAR_KIEK = 8;	//Kiek daugiausiai zvaigzdziu paryskinti vienu metu
	int		parNum[PAR_KIEK];	//Paryskintu zvaigzdziu numeriai
	float	parDuom[PAR_KIEK];	//Paryskintu zvaigzdziu duomenys (ryskumas)
	
	public:
	KFonas();
	~KFonas();
	void Sukurti();
	void ZvaigzdeAtstatyti(int);
	void Zvaigzde(int);
	void Atnaujinti();
	void Paryskinti();
	void Piesti();
} fonas;


#include "fonas.cpp"
#endif
