KObjektyvas::KObjektyvas(): dyd(1.0), kamp(50.0), gr(10.0), tek(0)
{
}


KObjektyvas::~KObjektyvas()
{
}


void KObjektyvas::Sukurti()
{
	memset(tekDuom, 0, tekDydis);
	for(i = 0; i < tekDydisi; i++){
		f = (((i * 2.0) * (i * 2.0) / tekX / tekX) + (i % tekX * 0.85) * (i % tekX * 0.85));
		f -= tekX * tekX * 0.75;
		f *= 0.09;	//Seselio koeficientas
		if(f < 0.0)
			f = 0.0;
		if(f > 255)
			f = 255;
		if((unsigned char)f < 255){
			f *= 0.6;
			tekDuom[i * 4 + 0] = 0;
			tekDuom[i * 4 + 1] = 0;
			tekDuom[i * 4 + 2] = 0;
		}
		else{
			tekDuom[i * 4 + 0] = 50 + rand() % 20;
			tekDuom[i * 4 + 1] = 50 + rand() % 20;
			tekDuom[i * 4 + 2] = 50 + rand() % 20;
		}
		tekDuom[i * 4 + 3] = (unsigned char)f;
		/*if(f > tekX * tekX * 0.8)
			tekDuom[i * 4 + 3] = 255;
		else if(f > tekX * tekX * 0.75)
			tekDuom[i * 4 + 3] = 100;*/
	}
	tekstura.Remelis(4);
	tek = tekstura.Sukurti();
}


void KObjektyvas::Atnaujinti()
{
	kamp -= laik * gr;
	if(kamp < 0.0)
		kamp = 0.0;
	if(kamp > 50.0)
		kamp = 50.0;
}


void KObjektyvas::PiestiDali()
{
	for(i = 0; i < 8; i++){
		glRotatef(360.0 / 8, 0.0, 0.0, 1.0);
		glPushMatrix();
		glTranslatef(0.3 + 0.5, 0.068, 0.0);
		glRotatef(-kamp, 0.0, 0.0, 1.0);
		glTranslatef(-0.5, 0.0, 0.0);
		glRotatef(-1.0, 1.0, 1.0, 0.0);
		geom.Plokst();
		glPopMatrix();
	}
}


void KObjektyvas::Piesti()
{
	glEnable(GL_ALPHA_TEST);
	glBindTexture(GL_TEXTURE_2D, tek);
	glAlphaFunc(GL_EQUAL, 1.0);
	PiestiDali();
	glDepthMask(GL_FALSE);
	glAlphaFunc(GL_LESS, 1.0);
	PiestiDali();
	glDepthMask(GL_TRUE);
	/*for(i = 0; i < 8; i++){
		glRotatef(360.0 / 8, 0.0, 0.0, 1.0);
		glPushMatrix();
		glTranslatef(0.3 + 0.5, 0.07, 0.0);
		glRotatef(-kamp, 0.0, 0.0, 1.0);
		glTranslatef(-0.5, 0.0, 0.0);
		glRotatef(-1.0, 1.0, 1.0, 0.0);
		//Piesti tekstura
		glDepthMask(GL_FALSE);
		geom.Plokst();
		//Irasyti depth reiksmes
		glColorMask(GL_FALSE, GL_FALSE, GL_FALSE, GL_FALSE);
		glDepthMask(GL_TRUE);
		glAlphaFunc(GL_GREATER, 0.9);
		geom.Plokst();
		glAlphaFunc(GL_GREATER, 0.0);
		glColorMask(GL_TRUE, GL_TRUE, GL_TRUE, GL_TRUE);
		glPopMatrix();
	}*/
	glDisable(GL_ALPHA_TEST);
}
