KTekstasDemke::KTekstasDemke(): faze(0), dydis(0.1), num(0), dydMaks(700.0)
{
}


KTekstasDemke::~KTekstasDemke()
{
}


void KTekstasDemke::Tekstas(const char *_t)
{
	ilgis = strlen(_t);
	tek = new char[ilgis];
	strncpy(tek, _t, ilgis);
}


void KTekstasDemke::Sukurti()
{
	Tekstas("DEMKEHAHAHA");
	
	float pozX = -0.11;
	float pozY = -0.29;
	dl = glGenLists(1);
	glNewList(dl, GL_COMPILE);
	glBegin(GL_QUADS);
		glNormal3f(0.0, 0.0, 1.0);
		glTexCoord2f(0.0, 0.18);	glVertex3f(pozX, pozY, 0.0);
		glTexCoord2f(0.82, 0.18);	glVertex3f(pozX + 1.0, pozY, 0.0);
		glTexCoord2f(0.82, 1.0);	glVertex3f(pozX + 1.0, pozY + 1.0, 0.0);
		glTexCoord2f(0.0, 1.0);	glVertex3f(pozX, pozY + 1.0, 0.0);
	glEnd();
	glEndList();
	
	f = -2.0 / tekstas.duomDydis;
	posl = -2.0;
	for(i = 0; i < 5; i++){
		posl += f;
		f /= tekstas.duomDydis;
	}
}


void KTekstasDemke::Atnaujinti()
{
	if(faze <= 1){
		dydis *= 1.01;
		if(dydis > dydMaks){
			if(num == ilgis - 6)
				++faze;
			if(num < ilgis - 3){
				++num;
				dydis /= (float)tekstas.duomDydis;
			}
			else
				++faze;
		}
	}
}


void KTekstasDemke::Piesti2(int id)
{
	glPushMatrix();
	for(int i = 0; i < tekstas.duomDydis; i++){
		glPushMatrix();
		for(int j = 22; j < tekstas.duomDydis; j++){
			if(tekstas.duom[(unsigned char)tek[id]][j * tekstas.duomDydis + i] > 0)
				glCallList(dl);
			glTranslatef(0.0, 1.0, 0.0);
		}
		glPopMatrix();
		glTranslatef(1.0, 0.0, 0.0);
	}
	glPopMatrix();
}


void KTekstasDemke::Piesti1()
{
	glPushMatrix();
	for(int i = 0; i < tekstas.duomDydis; i++){
		glPushMatrix();
		for(int j = 22; j < tekstas.duomDydis; j++){	// < tekstas.duomDydis
			if(tekstas.duom[(unsigned char)tek[num]][j * tekstas.duomDydis + i] > 0){
				if(i < 5 && j < 26){
					glBindTexture(GL_TEXTURE_2D, tekstas.tek[(unsigned char)tek[num + 2]]);
					//glColor4f(1.0, 1.0, 1.0, 0.16);
					if(dydis < dydMaks / 2.0)
						glColor4fv(balta);
					else
						glColor4f(1.0, 1.0, 1.0, 1.0 - (dydis - dydis / 2.0) / dydMaks * 2.0 * 0.84);
					glPushMatrix();
					glScalef(1.0 / tekstas.duomDydis, 1.0 / tekstas.duomDydis, 1.0);
					Piesti2(num + 1);
					glPopMatrix();
				}
				else{
					glBindTexture(GL_TEXTURE_2D, tekstas.tek[(unsigned char)tek[num + 1]]);
					glColor4f(1.0, 1.0, 1.0, 0.16);
					//if(dydis < dydMaks / 2.0)
					//	glColor4fv(balta);
					//else
					//	glColor4f(1.0, 1.0, 1.0, 1.0 - (dydis - dydis / 2.0) / dydMaks * 2.0 * 0.84);
					glCallList(dl);
				}
			}
			glTranslatef(0.0, 1.0, 0.0);
		}
		glPopMatrix();
		glTranslatef(1.0, 0.0, 0.0);
	}
	glPopMatrix();
}


void KTekstasDemke::Piesti()
{
	/*glBegin(GL_LINES);
	glVertex3f(-5.0, 0.0, 0.0);
	glVertex3f(5.0, 0.0, 0.0);
	glVertex3f(0.0, -5.0, 0.0);
	glVertex3f(0.0, 5.0, 0.0);
	glVertex3f(1.0, -5.0, 0.0);
	glVertex3f(1.0, 5.0, 0.0);
	glEnd();*/
	
	glPushMatrix();
	glColor4fv(balta);
	glScalef(dydis, dydis, 1.0);
	glScalef(1.0 / tekstas.duomDydis, 1.0 / tekstas.duomDydis, 1.0);
	glTranslatef(posl, posl, 0.0);
	if(dydis >= dydMaks / tekstas.duomDydis){
		Piesti1();
	}
	else{
		glBindTexture(GL_TEXTURE_2D, tekstas.tek[(unsigned char)tek[num + 1]]);
		glColor4f(1.0, 1.0, 1.0, 0.16);
		Piesti2(num);
	}
	glPopMatrix();
	
	/*glPushMatrix();
	//glTranslatef(-5.0, -2.0, 0.0);
	glScalef(1.0, 1.0, 1.0);
	for(int i = 0; i < ilgis; i++){
		glBindTexture(GL_TEXTURE_2D, tekstas.tek[(unsigned char)tek[i]]);
		glCallList(dl);
		glTranslatef(1.0, 0.0, 0.0);
	}
	glPopMatrix();*/
}
