#ifndef ZIEDAS2_HPP
#define ZIEDAS2_HPP


class KZiedas2
{
	public:
	GLuint	tek;	//Tekstura
	GLuint	tekCube;//CubeMap tekstura
	float	kh,		//Ziedo pasisukimas
			kv;
	float	dydis,
			dydisMin;
	float	plX,	//Plokstumos pozicija
			plY,
			plNX,	//Plokstumos nauja pozicija
			plNY;
	float	pas_h,	//Plokstumos pasisukimas
			pas_v;
	KTaskas	plokst;	//Kirtimo plokstumos normale
	bool	baigti;	//Ar stabdyti sukimasi?
	bool	baigta;	//Ar baigtas sukimasis?
	
	KZiedas2();
	~KZiedas2();
	
	void Sukurti();
	void Atnaujinti();
	void Baigti();
	void PiestiStencil();
	void Piesti();
	void PiestiZieda();
} ziedas2;


#include "ziedas2.cpp"
#endif
